import pygame, sys, random
from pygame.locals import *

# Richtet pygame ein.
pygame.init()
mainClock = pygame.time.Clock()

# Richtet das Fenster ein.
WINDOWWIDTH = 400
WINDOWHEIGHT = 400
windowSurface = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT), 0, 32)
pygame.display.set_caption('Collision Detection')

# Richtet die Farben ein.
BLACK = (0, 0, 0)
GREEN = (0, 255, 0)
WHITE = (255, 255, 255)

# Richtet die Datenstrukturen für die Figur und die Nahrungsquadrate ein.
foodCounter = 0
NEWFOOD = 40
FOODSIZE = 20
player = pygame.Rect(300, 100, 50, 50)
foods = []
for i in range(20):
    foods.append(pygame.Rect(random.randint(0, WINDOWWIDTH - FOODSIZE), random.randint(0, WINDOWHEIGHT - FOODSIZE), FOODSIZE, FOODSIZE))

# Richtet die Bewegungsvariablen ein.
moveLeft = False
moveRight = False
moveUp = False
moveDown = False

MOVESPEED = 6


# Führt die Spielschleife aus.
while True:
    # Prüft das Eintreten von Ereignissen.
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit()
            sys.exit()
        if event.type == KEYDOWN:
            # Ändert die Tastaturvariablen.
            if event.key == K_LEFT or event.key == K_a:
                moveRight = False
                moveLeft = True
            if event.key == K_RIGHT or event.key == K_d:
                moveLeft = False
                moveRight = True
            if event.key == K_UP or event.key == K_w:
                moveDown = False
                moveUp = True
            if event.key == K_DOWN or event.key == K_s:
                moveUp = False
                moveDown = True
        if event.type == KEYUP:
            if event.key == K_ESCAPE:
                pygame.quit()
                sys.exit()
            if event.key == K_LEFT or event.key == K_a:
                moveLeft = False
            if event.key == K_RIGHT or event.key == K_d:
                moveRight = False
            if event.key == K_UP or event.key == K_w:
                moveUp = False
            if event.key == K_DOWN or event.key == K_s:
                moveDown = False
            if event.key == K_x:
                player.top = random.randint(0, WINDOWHEIGHT - player.height)
                player.left = random.randint(0, WINDOWWIDTH - player.width)

        if event.type == MOUSEBUTTONUP:
            foods.append(pygame.Rect(event.pos[0], event.pos[1], FOODSIZE, FOODSIZE))

foodCounter += 1
    if foodCounter >= NEWFOOD:
        # Neues Nahrungsquadrat hinzufügen.
        foodCounter = 0
        foods.append(pygame.Rect(random.randint(0, WINDOWWIDTH - FOODSIZE), random.randint(0, WINDOWHEIGHT - FOODSIZE), FOODSIZE, FOODSIZE))

# Zeichnet den weißen Hintergrund auf die Oberfläche.
windowSurface.fill(WHITE)

    # Bewegt die Figur.
    if moveDown and player.bottom < WINDOWHEIGHT:
        player.top += MOVESPEED
    if moveUp and player.top > 0:
        player.top -= MOVESPEED
    if moveLeft and player.left > 0:
        player.left -= MOVESPEED
    if moveRight and player.right < WINDOWWIDTH:
        player.right += MOVESPEED

    # Zeichnet die Figur auf die Oberfläche.
    pygame.draw.rect(windowSurface, BLACK, player)

    # Prüft, ob die Figur mit Nahrungsquadraten überlappt.
    for food in foods[:]:
        if player.colliderect(food):
            foods.remove(food)
    
    # Zeichnet die Nahrungsquadrate.
    for i in range(len(foods)):
        pygame.draw.rect(windowSurface, GREEN, foods[i])

    # Zeichnet das Fenster auf den Bildschirm.
    pygame.display.update()
    mainClock.tick(40)
